#include "SAE.h"

ListeAdmission listenouv(void)
{
    ListeAdmission f;
    f = NULL;
    return f;
}

ListeAdmission adjq(ListeAdmission f, Admission candidat)
{
    MaillonAdmission *p;
    p = (MaillonAdmission *)malloc(sizeof(MaillonAdmission));
    if(p == NULL)
    {
        printf("Opérations interdites !!!!\n");
        exit(1);
    }
    p->v = candidat;
    if(vide(f))
    {
        p->suiv = p;
        return p;
    }
    p->suiv = f->suiv;
    f->suiv = p;
    return p;
}

ListeAdmission supt(ListeAdmission f)
{
    MaillonAdmission *aux;
    if(vide(f))
    {
        printf("Opérations interdites !!!!\n");
        exit(1);
    }
    if(f->suiv == f)
    {
        free(f);
        return Listenouv();
    }
    aux = f->suiv;
    f->suiv = aux->suiv;
    free(aux);
    return f;
}

bool vide(ListeAdmission f)
{
    return f == NULL;
}

Admission tete(ListeAdmission f)
{
    if(vide(f))
    {
        printf("Opérations interdites !!!!\n");
        exit(1);
    }
    return f->suiv->v;
}

int longueur(ListeAdmission f)
{
    int cpt = 1;
    MaillonAdmission *aux;
    if(vide(f))
    {
        return 0;
    }
    aux = f->suiv;
    while(aux != f)
    {
        cpt++;
        aux = aux->suiv;
    }
    return cpt;
}

void afficher(ListeAdmission f)
{
    MaillonAdmission *p=f;
    if(vide(f))
    {
        printf("Opérations interdites !!!!\n");
        exit(1);
    }
    afficherCandidats(f->v);
    while(f->suiv != p)
    {
        f = f->suiv;
        afficherCandidats(f->v);
    }
    printf("\n");
}